unit TreeViewPrintable;

interface


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ComCtrls, printers, Dialogs;

type
  TTreeViewPrintable = class(TTreeView)
  private
    procedure Impression(ANode : TTreeNode; ANiveau : integer);
  protected
  public
  published
    procedure Print;
  end;

var
  Y, Yo : integer;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Exemples', [TTreeViewPrintable]);
end;

// Bouton Imprimer l'Arbre
procedure TTreeViewPrintable.Print;
begin
  if (Items.Count = 0) then
    begin
      MessageDlg('Pas de slection  imprimer !', mtError, [mbOk], 0);
      Exit;
    end;

  Yo := 50;
  y := Yo;
  Printer.BeginDoc;
  Impression(TopItem, 0);
  printer.EndDoc;

  MessageDlg('Impression Finie !', mtInformation, [mbOk], 0);
end;

procedure TTreeViewPrintable.Impression;
var Bmp : TBitmap;
begin
  while ANode <> nil do
  begin
    if Images <> nil then
      begin
        // Impression Image de chaque ligne
        Bmp := TBitmap.Create;
        Images.GetBitmap(ANode.ImageIndex, Bmp);
        StretchBlt(Printer.Handle, ANiveau * Indent, Y,
                   printer.Canvas.TextHeight(ANode.Text), printer.Canvas.TextHeight(ANode.Text),
                   Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, SRCCOPY);
        Bmp.Free;
      end;

    // Impression de chaque ligne
    Printer.Canvas.TextOut((ANiveau * Indent) + 70, Y, ANode.Text);

    // Gestion du saut de page qq soit la taille de la page
    if (Y + 2 * (printer.Canvas.TextHeight(ANode.Text) + 10)) < printer.PageHeight
      then Inc(Y, printer.Canvas.TextHeight(ANode.Text) + 10)                      // 38 + 10
      else
        begin
          Y := Yo;
          printer.NewPage;
        end;

    // Relance la procedure pour imprimer les noeux enfants
    Impression(ANode.getFirstChild, ANiveau + 1);

    // Passe au Noeu suivant qui n'est pas un noeu enfant et ne remaonte pas au premier noeu
    ANode := ANode.getNextSibling;
  end;
end;



end.
